/** 
 * 
 * Copyright 2004 Protique Ltd
 * 
 * Licensed under the Apache License, Version 2.0 (the "License"); 
 * you may not use this file except in compliance with the License. 
 * You may obtain a copy of the License at 
 * 
 * http://www.apache.org/licenses/LICENSE-2.0
 * 
 * Unless required by applicable law or agreed to in writing, software
 * distributed under the License is distributed on an "AS IS" BASIS, 
 * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. 
 * See the License for the specific language governing permissions and 
 * limitations under the License. 
 * 
 **/
package org.activemq.transport.multicast;

import org.activemq.transport.DiscoveryAgent;
import org.activemq.transport.DiscoveryTransportChannelFactorySupport;

import javax.jms.JMSException;
import java.net.URI;
import java.net.URISyntaxException;

/**
 * A factory of multicast discovery transports
 *
 * @version $Revision: 1.1 $
 */
public class MulticastDiscoveryTransportChannelFactory extends DiscoveryTransportChannelFactorySupport {

    protected DiscoveryAgent createDiscoveryAgent(URI remoteLocation) throws JMSException, URISyntaxException {
        URI uri = new URI("multicast", remoteLocation.getUserInfo(), remoteLocation.getHost(), remoteLocation.getPort(), remoteLocation.getPath(), remoteLocation.getQuery(), remoteLocation.getFragment());
        return new MulticastDiscoveryAgent(uri);
    }
}

